--------------------------------------------------------------------------------
--	DIGITALER SINUS-GENERATOR
--
-- Modulname:			taktteiler2c.vhd
-- Projektname:		funktionsgenerator.ise
-- Ersteller:			Thomas Brunnengrber
--	Firma:				Privat
-- Erstellt:			26.03.2006
-- Zielsystem:			Spartan 3
-- Tool versions:		XILINX ISE 8.1
-- Revision:			1.0
-- Abhngigkeiten:	keine
--------------------------------------------------------------------------------
--	Teilt Takt_ein durch Potenzen von 2
-- Eingang fr asynchrones Lschen
--------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.all;

entity taktteiler2c is
	generic ( n : integer range 1 to 30 := 2 );	-- Takt-Teilung durch 2^n 
   port ( loeschen : in std_logic;
			 Takt_ein : in std_logic;
			 Takt_aus : out std_logic );
end taktteiler2c;

architecture arch1 of taktteiler2c is
	signal Zaehler : unsigned ( n-1 downto 0 ) := ( others => '0' ); 
begin
	process ( loeschen, Takt_ein )
	begin
		if loeschen = '1' then
			Zaehler <= ( others => '0' );
		elsif rising_edge( Takt_ein ) then
			Zaehler <= Zaehler + 1;
		end if;
	end process;
			
	Takt_aus <= std_logic( Zaehler( n-1 ) );

end arch1;
